asyncapi: '2.6.0'
info:
  title: Maestro WebSocket API
  version: 1.0.0

defaultContentType: application/json

channels:
  virtualMachine.{virtualMachineId}.status:
    description: Any update from virtualMachine status
    parameters:
      virtualMachineId:
        $ref: '#/components/parameters/virtualMachineId'
    subscribe:
      operationId: virtualMachineStatus
      message:
        $ref: '#/components/messages/virtualMachineStatus'
  virtualMachine.{virtualMachineId}.approval:
    description: Any update from virtualMachine approval
    parameters:
      virtualMachineId:
        $ref: '#/components/parameters/virtualMachineId'
    subscribe:
      operationId: virtualMachineApproval
      message:
        $ref: '#/components/messages/virtualMachineApproval'
  virtualMachine.{virtualMachineId}.isArchived:
    description: Any update from virtualMachine archive status
    parameters:
      virtualMachineId:
        $ref: '#/components/parameters/virtualMachineId'
    subscribe:
      operationId: virtualMachineIsArchived
      message:
        $ref: '#/components/messages/virtualMachineIsArchived'

components:
  messages:
    virtualMachineStatus:
      name: virtualMachineStatus
      title: Virtual machine status
      contentType: application/json
      payload:
        $ref: '#/components/schemas/virtualMachineStatus'
    virtualMachineApproval:
      name: virtualMachineApproval
      title: Virtual machine approval
      contentType: application/json
      payload:
        $ref: '#/components/schemas/virtualMachineApproval'
    virtualMachineIsArchived:
      name: virtualMachineIsArchived
      title: Virtual machine archive status
      contentType: application/json
      payload:
        $ref: '#/components/schemas/virtualMachineIsArchived'

  schemas:
    virtualMachineStatus:
      type: object
      properties:
        status:
          type: string
          enum: ['ONLINE', 'OFFLINE']
          description: Status of a virtual machine
    virtualMachineApproval:
      type: object
      properties:
        status:
          type: string
          enum: ['NONE', 'IN_PROGRESS', 'APPROVED']
          description: Approval status of a virtual machine
    virtualMachineIsArchived:
      type: boolean

  parameters:
    virtualMachineId:
      description: The ID of the virtual machine
      schema:
        type: string
